<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="ZyTrax">
<meta name="keywords" content="Wireless IP, ISDN, QoS, Bandwidth Management, ZyTrax, Proxy, IP Telephony, VoIP,Firewall, Router">
<title>Web Maintenance Tools - Response page</title>
<?php 
  virtual ("../templates/styles.shtml");
	virtual ("../scripts/js.shtml");
?>
</head>
<body>
<?php 
  virtual ("../templates/nav_top.shtml");
?>
<div class="l-c">

<!-- body (main) text here -->
<?php 
		if (!($f =="d" && $from==""))
		{
			if($directory=="" or $from == "")
			{
				echo "Invalid 'directory' (".$directory.") or 'containing' (".$from."). Resubmit";
			}
			else
			{
				$last_file = "";
			exec("/bin/grep -r '$from' $directory", $results, $errorCode); 
    	if ($errorCode)
			{ 
        	if ($errorCode == 1)
					{ 
            	echo "Possibly no files were found with '".$from."' in them<BR>\n"; 
        	} 
      		echo "OS Error:".$errorCode."<BR>\n"; 
      		echo "Maybe paths/permissions<BR>\n"; 
    	}
			else
			{
    		echo "Found ".count($results)." files<br>\n";
				if($f != "d")
				{
					// clean strings in case
					$clean_from = stripslashes($from);
					$clean_to = stripslashes($to);
				}
				while (list(,$path) = each($results))
				{ 
        		
					$parts = explode(':', $path); 
        	$path = $parts[0]; 
      		if($last_file != $path)	// ignore duplicates
					{
						if ($f == "r")
						{
							$fp = fopen($path, 'r') or print("Cannot read $path<BR>\n"); 
      					if ($fp)
		  					{
        					$data = fread($fp, filesize($path)); 
        					fclose($fp); 
        					$newdata = str_replace($clean_from, $clean_to, $data); 
        					$fp = fopen($path, 'w') or print("Cannot write $path<BR>\n"); 
        					if ($fp)
								{ 
          						fwrite($fp, $newdata); 
          						fclose($fp); 
          						echo "Updated ".$path, "<BR>\n"; 
        					} 
      					}
						
						}
						elseif ($f =="d")
						{
							// display found file
							$contents = file($path); 
							echo "Found in ".$path."<br>\n";
							if ($type == "list")	// only if full lsy required
							{
								while(list ($line_num,$line) = each($contents))
								{
									echo ++$line_num." ".htmlspecialchars( $line)."<br>\n";
								}
							}
						}
						else
						{
							// insert or delete line in file
							echo $op." ".$where." in ".$path."<br>\n";
							$contents = file($path); 
							$found = 0;
							$length = count($contents);
							for($i=0; $i<$length;$i++)
							{
								$line = $contents[$i];
								$pos = strpos($line, $clean_from);
								if ($pos === false)
								{
								}
								else
								{
									$found = 1;
									// found the string 
									if ($where == "above")
									{
										if ($op=="insert")
										{
											$front = array_slice( $contents,0,$i);
										}
										else
										{
											$front =array_slice( $contents,0,$i-1);
										}
										$back = array_slice($contents,$i);
									}
									else
									{
										// below
										$front = array_slice($contents,0,$i+1);
										if ($op=="insert")
										{
											$back = array_slice( $contents, $i+1);
										}
										else
										{
											$back = array_slice( $contents, $i+2);
										}
									}
									if($op == "insert")
									{
										$front[] = $clean_to."\n"; // add line
									}
									$contents = array_merge($front, $back);
									++$length;
									++$i;
								}
							}
							if ($found)
							{
								// re-write file
								$fp = fopen($path, 'w') or print("Cannot write $path<BR>\n"); 
								if($fp)
								{
									while(list(,$line) = each($contents))
									{
										fwrite($fp,$line);
									}
									fclose($fp); 
								}
							}
						
						}
					
					}
				}
			}
			} // invalid vet
    }
		else
		{
			// single file to display
			$contents = file($directory) or print("Not found = $directory<br>\n"); 
			if(count($contents) > 1)
			{
				echo "File name = ".$directory."<br>\n";
				while(list ($line_num,$line) = each($contents))
				{
					echo ++$line_num." ".htmlspecialchars($line)."<br>\n";
				}
			}
		} 
?>
</div>
	<!-- end body table -->

<?php
	$real_date = date("F d, Y.", getlastmod()); 
  virtual ("../templates/footer.php");
	virtual ("../templates/nav_popout1.shtml");
?>
</body>
</html>