<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="ZyTrax">
<meta name="keywords" content="Wireless IP, ISDN, QoS, Bandwidth Management, ZyTrax, Proxy, IP Telephony, VoIP,Firewall, Router">
<title>Web Tools - Update Response</title>
<!-- <?php echo "page saved from http://".$HTTP_HOST.$REQUEST_URI; ?> -->
<?php 
	define("MAGIC_NUMBER","LEVEL117XDB");
  virtual ("../templates/styles.shtml");
	virtual ("../scripts/js.shtml");
?>
</head>
<body>
<?php 
  virtual ("../templates/nav_top.shtml");
	include ("/var/www/zytrax-cgi/thingy.php");
?>
<!-- begin body table -->
<div class="l-c">
<div class="l-100">
<?php
// start application here
// initialise globals and variables
$f = new thingy;
$t = new thingy;
$vet_err = 0;
// initialse all arrays
$f_dirs[] = "";
$f_files[0][0] = "";	// multi-array [0] = name [1] = time
$t_dirs[] = "";
$t_files[0][0] = "";	// multi-array [0] = name [1] = time
$all_dirs[] = "";
array_splice($all_dirs,0); // creates zero entry array
$end_it = 0;
$php_dir = getcwd();	// save working directory
$current_dir = "";
// get from_base and to_base
$f->base = trim($from);
$t->base = trim($dest);
$t->op = $op;
$f->op = $op;
// see if web or directory and vet supplied params
if (!($f->where($fname, $fpass)))
{
	echo "From Param error<br>\n";
	$vet_err = 1;
}
if (!($t->where($tname, $tpass)))
{
	echo "To Param error<br>\n";
	$vet_err = 1;
}
if($t->type == "web" and $f->type == "web")
{
	echo "Web to web - not supported<br>\n";
	$vet_err = 1;
}
echo "From = ".$f->base." Type=".$f->type." To = ".$t->base." Type=".$t->type." Op = ".$op."<br>\n";
// terminate now if vet errors
if($vet_err != 1)
{
	// continue normally
	if (!($f->open())){
		$f->close();
		echo "error source";
	}else{
		if(!($t->open())){
			$t->close();
			$f->close();
			echo "error dest";
		}else{
			//for($i = 0;$i<40;$i++)
			while(1){
				// read files from current from and to directories
				if($f->read($f_dirs, $f_files) == false){
					echo "Read from error<br>\n";
					break;
				}
				// optionally add exclusion list check here
				if($t->read($t_dirs, $t_files) == false){
					echo "Read to error<br>\n";
					break;
				}
				$dir_count = count($f_dirs);
				$file_count = count($f_files);
				$t_file_count = count($t_files);
				$f_dir_count = count($t_dirs);
				// echo "Counts D= ".$dir_count." F= ".$file_count."<br>\n";
				if($file_count and is_array($f_files)){
					// first pass just adds all new or updates old files
					if(!($t->update_files($f,$f_files,$t_files))){
						echo "File Update error<br>\n";
						break;
					}
				}
				// second pass synchronises or updates depending on setting of $op
				if(!($t->sync_files($f_files,$t_files))){
					echo "File Sync error<br>\n";
					break;
				}
				// do the same in two passes for directories
				if($dir_count and is_array($f_files) and $r == "yes"){
					if(!($t->update_dirs($f_dirs, $t_dirs))){
						echo "Dir Update error<br>\n";
						break;
					}else{
						// add new level to master dir array
						// magic number indicates the break in level so we can move up and down
						// directory structure when recursing
						$all_dirs[] = MAGIC_NUMBER;
						// create single array 
						$all_dirs = array_merge($all_dirs,$f_dirs);	
						// echo "Merged = ".count($all_dirs)."<br>\n";
						// print_r($all_dirs);
						// suppress 'up' in ->down!
						// we are forcing the directory pointer down
						// when we go 'accross' directories we have to go up then down 
						// to get to next directory
						$f->down_only = true;
						$t->down_only = true;
					}
				}
				// sync dirs if necessary
				if(!($t->sync_dirs($f_dirs, $t_dirs))){
					echo "Dir Sync error<br>\n";
					break;
				}
				if(count($all_dirs) == 0){
					break;
				}
				$current_dir = array_pop($all_dirs);
				// echo "Changed dir= ".$current_dir."<br>\n";
				// when we reach the last MAGIC_NUMBER we have finished all iterations
				while($current_dir == MAGIC_NUMBER){
					if(count($all_dirs) == 0){
						$end_it = 1;
						break;	// finished
					}
					$current_dir = array_pop($all_dirs);
					// position at previous level
					if($f->up() == false){
						echo "From 'up' error<br>\n";
						$end_it = 1;
						break;
					}
					if($t->up() == false){
						$end_it = 1;
						echo "To 'up' error<br>\n";
						break;
					}
				}
				if($end_it){
					break;
				}
				// valid directory at current level
				if($f->down($current_dir) == false){
					echo "From 'down' error<br>\n";
					break;
				}
				if($t->down($current_dir) == false){
					echo "To 'down' error<br>\n";
					break;
				}
				// echo "Change dir= ".$current_dir."<br>\n";
			}
			echo "** Read ".$f->files_read." files ".$f->dirs_read." dirs ** Copied= ".$t->copied." Created= ".$t->created." New Dirs= ".$t->new_dirs." Deleted Dirs= ".$t->del_dirs." files= ".$t->del_files."<br>\n";
			// termination
			$f->close();
			$t->close();
		}
	}
chdir($php_dir);	// restore directory
}
?>

	<!-- end body table -->
	</div>
	</div>
<?php
	$real_date = date("F d, Y.", getlastmod()); 
  include ("../templates/footer.php");
	virtual ("../templates/nav_popout1.shtml");
?>
</body>
</html>